/**************************************************
 *
 *
 **************************************************
 * This code was created by Peter Harvey @ CodeByDesign.
 * Released under GPL 18.FEB.99
 *
 * Contributions from...
 * -----------------------------------------------
 * Peter Harvey		- pharvey@codebydesign.com
 **************************************************/
#include "classDataManager.h"
#include "LinuxODBC.xpm"

classDataManager::classDataManager( QWidget *pParent, const char *pszName )
	: QWidget( pParent, pszName ) //, 503808 )
{
	setCaption( "DataManager " VERSION );

	setIcon( QPixmap( LinuxODBC_xpm ) );

	splSplitter = new QSplitter( this, "splSplitter" );

	lvwBrowser = new QListView( splSplitter, "lvwBrowser" );
	lvwBrowser->setMinimumSize( 50, 50 );
	lvwBrowser->setMaximumSize( 32767, 32767 );
	connect( lvwBrowser, SIGNAL(rightButtonClicked(QListViewItem*,const QPoint&,int)), SLOT(ItemMenu(QListViewItem*,const QPoint&,int)) );
	connect( lvwBrowser, SIGNAL(selectionChanged(QListViewItem*)), SLOT(ItemChanged(QListViewItem*)) );
	lvwBrowser->setFocusPolicy( QWidget::TabFocus );
	lvwBrowser->setBackgroundMode( QWidget::PaletteBackground );
	lvwBrowser->setFontPropagation( QWidget::NoChildren );
	lvwBrowser->setPalettePropagation( QWidget::NoChildren );
	lvwBrowser->setFrameStyle( 17 );
	lvwBrowser->setResizePolicy( QScrollView::Manual );
	lvwBrowser->setVScrollBarMode( QScrollView::Auto );
	lvwBrowser->setHScrollBarMode( QScrollView::Auto );
	lvwBrowser->setTreeStepSize( 20 );
	lvwBrowser->setMultiSelection( FALSE );
	lvwBrowser->setAllColumnsShowFocus( TRUE );
	lvwBrowser->setItemMargin( 1 );
	lvwBrowser->setRootIsDecorated( TRUE );
	lvwBrowser->addColumn( "Object", -1 );
	lvwBrowser->setColumnWidthMode( 0, QListView::Maximum );
	lvwBrowser->setColumnAlignment( 0, 1 );
	lvwBrowser->addColumn( "Description", -1 );
	lvwBrowser->setColumnWidthMode( 1, QListView::Maximum );
	lvwBrowser->setColumnAlignment( 1, 1 );

	pCanvas = new classCanvas( splSplitter, "fraProperties" );
	pCanvas->setMinimumSize( 50, 50 );
	pCanvas->setMaximumSize( 32767, 32767 );
	pCanvas->setFocusPolicy( QWidget::NoFocus );
	pCanvas->setBackgroundMode( QWidget::PaletteBackground );
	pCanvas->setFontPropagation( QWidget::NoChildren );
	pCanvas->setPalettePropagation( QWidget::NoChildren );

	resize( 400,480 );
	setMinimumSize( 0, 0 );
	setMaximumSize( 32767, 32767 );

	pODBC = new classODBC( lvwBrowser, pCanvas );

}

classDataManager::~classDataManager()
{

}

void classDataManager::ItemMenu(QListViewItem *pItem, const QPoint &, int )
{

    if ( pItem == 0 ) return;
    lvwBrowser->setSelected( pItem, TRUE );

}

void classDataManager::ItemChanged(QListViewItem *pItem )
{
    QString         qsType;

    if ( pItem == 0 ) return;
    lvwBrowser->setSelected( pItem, TRUE );
	pODBC->selectionChanged( pItem );
}

void classDataManager::Exit()
{
    exit( 0 );
}

void classDataManager::About()
{

}

void classDataManager::resizeEvent( QResizeEvent * )
{
    int marg = 1;
    int w = width()  - marg * 2;
    int h = height() - marg * 2;

    splSplitter->setGeometry( marg, marg, w, h );
}



