#include "driver.h"

HLST _CreateBoundCols( SQLHSTMT	hDrvStmt )
{
    HDRVSTMT		hStmt			= (HDRVSTMT)hDrvStmt;
	HLST 			hBoundCols;
    HBOUNDCOLUMN	pBoundColumn;

	sprintf( hStmt->szSqlMsg, "hStmt = $%08lX", hStmt );
    logPushMsg( hStmt->hLog, __FILE__, __FILE__, __LINE__, LOG_WARNING, LOG_WARNING, hStmt->szSqlMsg );

	if ( !hStmt->hStmtExtras->hStmt->hTableResult )
	{
		logPushMsg( hStmt->hLog, __FILE__, __FILE__, __LINE__, LOG_WARNING, LOG_WARNING, "SQL_ERROR Called with no result table" );
		return NULL;
	}

	hBoundCols = lstOpen();		/* default free function is ok */

	lstFirst( hStmt->hStmtExtras->hStmt->hTableResult->hColHdrs );
	while ( !lstEOL( hStmt->hStmtExtras->hStmt->hTableResult->hColHdrs ) )
	{
		pBoundColumn = malloc( sizeof(BOUNDCOLUMN) );
        pBoundColumn->nTargetType			= -1;
        pBoundColumn->nTargetValueMax		= 0;
        pBoundColumn->pColumn				= (HSQICOLUMN)lstGet( hStmt->hStmtExtras->hStmt->hTableResult->hColHdrs );
		pBoundColumn->pnLengthOrIndicator	= NULL;
        pBoundColumn->pTargetValue			= NULL;
		lstAppend( hBoundCols, pBoundColumn );

		lstNext( hStmt->hStmtExtras->hStmt->hTableResult->hColHdrs );
	}

    logPushMsg( hStmt->hLog, __FILE__, __FILE__, __LINE__, LOG_INFO, LOG_INFO, "SQL_SUCCESS" );

    return hBoundCols;
}



