/**********************************************************************
 * _Prepare
 *
 **********************************************************************
 *
 * This code was created by Peter Harvey (mostly during Christmas 98/99).
 * This code is LGPL. Please ensure that this message remains in future
 * distributions and uses of this code (thats about all I get out of it).
 * - Peter Harvey pharvey@codebydesign.com
 *
 **************************************************
 * Contributions from...
 * -----------------------------------------------
 * PAH = Peter Harvey		- pharvey@codebydesign.com
 * -----------------------------------------------
 *
 * PAH	05.APR.99	Added a hack for positional update/deletes.
 *
 **************************************************/

#include "driver.h"

SQLRETURN _Prepare(	SQLHSTMT    hDrvStmt,
					SQLCHAR     *szSqlStr,
					SQLINTEGER  nSqlStrLength )
{	
    HDRVSTMT 	hStmt		= (HDRVSTMT)hDrvStmt;

	/* SANITY CHECKS */
	if ( !hStmt )
		return SQL_INVALID_HANDLE;

	sprintf( hStmt->szSqlMsg, "hStmt = $%08lX", hStmt );
	logPushMsg( hStmt->hLog, __FILE__, __FILE__, __LINE__, LOG_WARNING, LOG_WARNING, hStmt->szSqlMsg );

	if ( !szSqlStr )
	{
		logPushMsg( hStmt->hLog, __FILE__, __FILE__, __LINE__, LOG_WARNING, LOG_WARNING, "SQL_ERROR No SQL to process" );
		return SQL_ERROR;
	}

	if ( hStmt->pszQuery )
	{
		logPushMsg( hStmt->hLog, __FILE__, __FILE__, __LINE__, LOG_WARNING, LOG_WARNING, "SQL_ERROR Statement already in use." );
		return SQL_ERROR;
	}

	/***************************************
	 * DO WHAT WE HAVE TO DO FOR THE DBMS SELECT OR WHAT EVER
	 ***************************************/
	if ( !sqiPrepare( hStmt->hStmtExtras->hStmt, szSqlStr ) )
	{
		/* peek at last message */
		logPushMsg( hStmt->hLog, __FILE__, __FILE__, __LINE__, LOG_WARNING, LOG_WARNING, hStmt->hStmtExtras->hStmt->szMsg );
		return SQL_ERROR;
	}

	hStmt->pszQuery = (char *)strdup( szSqlStr );

	logPushMsg( hStmt->hLog, __FILE__, __FILE__, __LINE__, LOG_INFO, LOG_INFO, "SQL_SUCCESS" );
	return SQL_SUCCESS;
}



