/**************************************************
 * 
 *
 **************************************************
 * This code was created by Peter Harvey @ CodeByDesign. 
 * Released under GPL 31.JAN.99
 *
 * Contributions from...
 * -----------------------------------------------
 * Peter Harvey		- pharvey@codebydesign.com
 **************************************************/
#include "classDriverPrompt.h"

#define Inherited classDriverPromptData

classDriverPrompt::classDriverPrompt( QWidget* parent, const char* name )
	: Inherited( parent, name )
{
	setCaption( "Adding a new data source" );
	qsDriverName	= "";
	qsDescription		= "";
	qsDriver		= "";
	qsSetup			= "";
}


classDriverPrompt::~classDriverPrompt()
{
}

/********************************************
 * protected slots
 ********************************************/

void classDriverPrompt::pbCancel_Clicked()
{
	reject();
}

void classDriverPrompt::pbOk_Clicked()
{
    QListView		*pListView;
    QListViewItem	*pListViewItem;

	pListView		= pDrivers->getListView();
	pListViewItem	= pListView->currentItem();

	if ( pListViewItem )
	{
		qsDriverName	= pListViewItem->text( 0 );
		qsDescription		= pListViewItem->text( 1 );
		qsDriver		= pListViewItem->text( 2 );
		qsSetup			= pListViewItem->text( 3 );
		if ( qsDriverName == "" )
			QMessageBox::information(	this, "ODBC Config",  "Please select a listing which contains a Driver file name" );
		else
			accept();
	}
	else
		QMessageBox::information(	this, "ODBC Config",  "Please select a Driver from the list or click Cancel" );
}



