#include <qpixmap.h>
#include <qlayout.h>
#include "classDriversData.h"
#include "driver.xpm"

#define Inherited QWidget

#include <qlabel.h>
#include <qframe.h>

classDriversData::classDriversData
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name, 0 )
{
	pbAdd = new QPushButton( this, "pbAdd" );
	pbAdd->setGeometry( 290, 10, 100, 30 );
	pbAdd->setMinimumSize( 0, 0 );
	pbAdd->setMaximumSize( 32767, 32767 );
	pbAdd->setFocusPolicy( QWidget::TabFocus );
	pbAdd->setBackgroundMode( QWidget::PaletteBackground );
	pbAdd->setFontPropagation( QWidget::NoChildren );
	pbAdd->setPalettePropagation( QWidget::NoChildren );
	pbAdd->setText( "A&dd..." );
	pbAdd->setAutoRepeat( FALSE );
	pbAdd->setAutoResize( FALSE );

	pbRemove = new QPushButton( this, "pbRemove" );
	pbRemove->setGeometry( 290, 50, 100, 30 );
	pbRemove->setMinimumSize( 0, 0 );
	pbRemove->setMaximumSize( 32767, 32767 );
	pbRemove->setFocusPolicy( QWidget::TabFocus );
	pbRemove->setBackgroundMode( QWidget::PaletteBackground );
	pbRemove->setFontPropagation( QWidget::NoChildren );
	pbRemove->setPalettePropagation( QWidget::NoChildren );
	pbRemove->setText( "&Remove" );
	pbRemove->setAutoRepeat( FALSE );
	pbRemove->setAutoResize( FALSE );

	pbConfigure = new QPushButton( this, "pbConfigure" );
	pbConfigure->setGeometry( 290, 90, 100, 30 );
	pbConfigure->setMinimumSize( 0, 0 );
	pbConfigure->setMaximumSize( 32767, 32767 );
	pbConfigure->setFocusPolicy( QWidget::TabFocus );
	pbConfigure->setBackgroundMode( QWidget::PaletteBackground );
	pbConfigure->setFontPropagation( QWidget::NoChildren );
	pbConfigure->setPalettePropagation( QWidget::NoChildren );
	pbConfigure->setText( "&Configure..." );
	pbConfigure->setAutoRepeat( FALSE );
	pbConfigure->setAutoResize( FALSE );

	lvwDrivers = new QListView( this, "lvwDrivers" );
	lvwDrivers->setGeometry( 10, 10, 270, 190 );
	lvwDrivers->setMinimumSize( 0, 0 );
	lvwDrivers->setMaximumSize( 32767, 32767 );
	lvwDrivers->setFocusPolicy( QWidget::TabFocus );
	lvwDrivers->setBackgroundMode( QWidget::PaletteBackground );
	lvwDrivers->setFontPropagation( QWidget::NoChildren );
	lvwDrivers->setPalettePropagation( QWidget::NoChildren );
	lvwDrivers->setFrameStyle( 17 );
	lvwDrivers->setResizePolicy( QScrollView::Manual );
	lvwDrivers->setVScrollBarMode( QScrollView::Auto );
	lvwDrivers->setHScrollBarMode( QScrollView::Auto );
	lvwDrivers->setTreeStepSize( 20 );
	lvwDrivers->setMultiSelection( FALSE );
	lvwDrivers->setAllColumnsShowFocus( FALSE );
	lvwDrivers->setItemMargin( 1 );
	lvwDrivers->setRootIsDecorated( FALSE );
	lvwDrivers->addColumn( "Name", -1 );
	lvwDrivers->setColumnWidthMode( 0, QListView::Maximum );
	lvwDrivers->setColumnAlignment( 0, 1 );
	lvwDrivers->addColumn( "Description", -1 );
	lvwDrivers->setColumnWidthMode( 1, QListView::Maximum );
	lvwDrivers->setColumnAlignment( 1, 1 );
	lvwDrivers->addColumn( "Driver Lib", -1 );
	lvwDrivers->setColumnWidthMode( 2, QListView::Maximum );
	lvwDrivers->setColumnAlignment( 2, 1 );
	lvwDrivers->addColumn( "Setup Lib", -1 );
	lvwDrivers->setColumnWidthMode( 3, QListView::Maximum );
	lvwDrivers->setColumnAlignment( 3, 1 );

	QFrame* qtarch_Frame_2;
	qtarch_Frame_2 = new QFrame( this, "Frame_2" );
	qtarch_Frame_2->setGeometry( 10, 204, 380, 90 );
	qtarch_Frame_2->setMinimumSize( 0, 0 );
	qtarch_Frame_2->setMaximumSize( 32767, 32767 );
	qtarch_Frame_2->setFocusPolicy( QWidget::NoFocus );
	qtarch_Frame_2->setBackgroundMode( QWidget::PaletteBackground );
	qtarch_Frame_2->setFontPropagation( QWidget::NoChildren );
	qtarch_Frame_2->setPalettePropagation( QWidget::NoChildren );
	qtarch_Frame_2->setFrameStyle( 33 );

	QLabel* qtarch_Label_1;
	qtarch_Label_1 = new QLabel( this, "Label_1" );
	qtarch_Label_1->setGeometry( 70, 210, 310, 70 );
	qtarch_Label_1->setMinimumSize( 0, 0 );
	qtarch_Label_1->setMaximumSize( 32767, 32767 );
	qtarch_Label_1->setFocusPolicy( QWidget::NoFocus );
	qtarch_Label_1->setBackgroundMode( QWidget::PaletteBackground );
	qtarch_Label_1->setFontPropagation( QWidget::NoChildren );
	qtarch_Label_1->setPalettePropagation( QWidget::NoChildren );
	qtarch_Label_1->setText( "These drivers facilitate communication between the Driver Manager and the data server. Many ODBC drivers  for Linux can be downloaded from the Internet while others are obtained from your database vendor." );
	qtarch_Label_1->setAlignment( 1313 );
	qtarch_Label_1->setMargin( -1 );

	QLabel* qtarch_Label_2;
	qtarch_Label_2 = new QLabel( this, "Label_2" );
	qtarch_Label_2->setGeometry( 30, 230, 32, 32 );
	qtarch_Label_2->setMinimumSize( 32, 32 );
	qtarch_Label_2->setMaximumSize( 32, 32 );
	qtarch_Label_2->setBackgroundPixmap( QPixmap( driver_xpm ) );
	qtarch_Label_2->setFocusPolicy( QWidget::NoFocus );
	qtarch_Label_2->setFontPropagation( QWidget::NoChildren );
	qtarch_Label_2->setPalettePropagation( QWidget::NoChildren );
	qtarch_Label_2->setText( "" );
	qtarch_Label_2->setAlignment( 289 );
	qtarch_Label_2->setMargin( -1 );

	resize( 400,300 );
	setMinimumSize( 0, 0 );
	setMaximumSize( 32767, 32767 );
}


classDriversData::~classDriversData()
{
}
