/**************************************************
 *
 *
 **************************************************
 * This code was created by Peter Harvey @ CodeByDesign.
 * Released under GPL 31.JAN.99
 *
 * Contributions from...
 * -----------------------------------------------
 * Peter Harvey		- pharvey@codebydesign.com
 **************************************************/
#include "classODBCConfig.h"
#include "smallLinuxODBC.xpm"

#define Inherited classODBCConfigData

classODBCConfig::classODBCConfig( QWidget* parent, const char* name )
	: Inherited( parent, name )
{
   setIcon( QPixmap( smallLinuxODBC_xpm ) );
   setCaption( "ODBC Data Source Administrator " VERSION );
   pUserDSN       = new classUserDSN( fraTabFrame );
   pSystemDSN     = new classSystemDSN( fraTabFrame );
   pDrivers       = new classDrivers( fraTabFrame );
   pTracing       = new classTracing( fraTabFrame );
   pAbout         = new classAbout( fraTabFrame );
   
//   pTracing->setGeometry( 10, 10, 300, 300 );
}


classODBCConfig::~classODBCConfig()
{
}

void classODBCConfig::TabChanged( int nTab )
{
    QString qsError;

    pUserDSN->hide();
    pSystemDSN->hide();
    pDrivers->hide();
	pTracing->hide();
    pAbout->hide();

    qsError.sprintf( "nTab=%d", nTab );

    switch ( nTab )
    {
    case TAB_USERDSN:
        pUserDSN->show();
        break;
    case TAB_SYSTEMDSN:
        pSystemDSN->show();
        break;
    case TAB_DRIVERS:
        pDrivers->show();
        break;
    case TAB_TRACING:
        pTracing->show();
        break;
    case TAB_ABOUT:
        pAbout->show();
        break;
    default:
        QMessageBox::information( this, "ODBC Config", "Unknown tab " + qsError );
    }
}

