/**************************************************
 * 
 *
 **************************************************
 * This code was created by Peter Harvey @ CodeByDesign. 
 * Released under GPL 31.JAN.99
 *
 * Contributions from...
 * -----------------------------------------------
 * Peter Harvey		- pharvey@codebydesign.com
 **************************************************/
#ifndef classODBCConfig_included
#define classODBCConfig_included

#include <qmessagebox.h>
#include <qpixmap.h>

#include "classODBCConfigData.h"
#include "classUserDSN.h"
#include "classSystemDSN.h"
#include "classDrivers.h"
#include "classAbout.h"
#include "classTracing.h"

class classODBCConfig : public classODBCConfigData
{
    Q_OBJECT

public:
    enum tabs { TAB_USERDSN, TAB_SYSTEMDSN, TAB_DRIVERS, TAB_TRACING, TAB_ABOUT };

    classODBCConfig( QWidget* parent = NULL, const char* name = NULL );
    virtual ~classODBCConfig();

private:
    classUserDSN    *pUserDSN;
    classSystemDSN  *pSystemDSN;
    classDrivers    *pDrivers;
    classTracing    *pTracing;
    classAbout      *pAbout;

protected slots:
    void TabChanged(int);

};
#endif 
