#include "sqi.h"

/********************************************
 * _sqiGetTableFileName
 *
 ********************************************/

int _sqiGetTableFileName( HSQISTMT hStmt, char *pszCatalogFile, char *pszTableName, char *pszTableFile )
{
	HINI		hIni;

	if ( iniOpen( &hIni, pszCatalogFile, ';', '[', ']', '=', false ) != INI_SUCCESS )
	{
		sprintf( hStmt->szMsg, "Could not open catalog file (%s)", pszCatalogFile );
		logPushMsg( hStmt->hLog, __FILE__, __FILE__, __LINE__, LOG_CRITICAL, SQI_ERROR, hStmt->szMsg );
		return false;
	}
	
	if ( iniObjectSeek( hIni, pszTableName ) != INI_SUCCESS )
	{
		sprintf( hStmt->szMsg, "Could not find table (%s)", pszTableName );
		logPushMsg( hStmt->hLog, __FILE__, __FILE__, __LINE__, LOG_CRITICAL, SQI_ERROR, hStmt->szMsg );
		iniClose( hIni );
		return false;
	}

	if ( iniPropertySeek( hIni, pszTableName, "FILE", "" ) != INI_SUCCESS )
	{
		sprintf( hStmt->szMsg, "Could not find table file name for (%s)", pszTableName );
		logPushMsg( hStmt->hLog, __FILE__, __FILE__, __LINE__, LOG_CRITICAL, SQI_ERROR, hStmt->szMsg );
		iniClose( hIni );
		return false;
	}
	iniValue( hIni, pszTableFile );

	iniClose( hIni );

	return true;
}

