#include "sqi.h"

/*******************
 * This can be called for a cursor or for a root table
 * but is usually called to save updates that have been
 * made on a root table.
 *******************/
int _sqiSaveTable( HSQITABLE hTable, char *pszTableFile )
{
	FILE 		*hFile;
/*	HSQICOLUMN	pColumn; */
	char		**aCols;
	int			nCol;

	/**************
	 * SANITY CHECKS
	 **************/
	if ( !hTable )
		return false;

	if ( !pszTableFile )
		return false;

/***********[ good place for a table lock ]************/

	hFile = fopen( pszTableFile, "w" );
	if ( !hFile )
		return false;

	/**************
	 * COLUMN HEADERS
	 **************/
/* DISABLED - COLUMN NAMES NOW STORED IN DATABASE FILE (NOT TABLE FILE)
	lstFirst( hTable->hColHdrs );
	while ( !lstEOL( hTable->hColHdrs ) )
	{
		pColumn = (HSQICOLUMN)lstGet( hTable->hColHdrs );
		if ( hTable->hColHdrs->hCurrent == hTable->hColHdrs->hFirst )
			fprintf( hFile, "%s", pColumn->pszSQL_DESC_BASE_COLUMN_NAME );
		else
			fprintf( hFile, ",%s", pColumn->pszSQL_DESC_BASE_COLUMN_NAME );

		lstNext( hTable->hColHdrs );
	}
	fprintf( hFile, "\n" );
*/

	/**************
	 * ROW DATA
	 **************/
	lstFirst( hTable->hRows );
	while ( !lstEOL( hTable->hRows ) )
	{
		aCols = (char**)lstGet( hTable->hRows );
		for ( nCol = 0; (nCol < hTable->hColHdrs->nItems) && aCols[nCol]; nCol++ )
		{
			if ( nCol == 0 )
				fprintf( hFile, "%s", aCols[nCol] );
			else
				fprintf( hFile, ",%s", aCols[nCol] );
		}
		fprintf( hFile, "\n" );
		lstNext( hTable->hRows );
	}


	/**************
	 * CLEANUP
	 **************/
	fclose( hFile );

	return true;
}

