#include "sqi.h"

/********************************************
 * sqiOpen
 *
 ********************************************/
int sqiOpen( HSQI *phSQI, char *pszCatalogFile )
{
	HSQI 	hSQI;
	HLOG	hLog;

	if ( !pszCatalogFile )
		return false;
	
	if ( !logOpen( &hLog, "SQI", NULL, 20 ) )
		return false;
	logOn( hLog, true );

	hSQI = malloc( sizeof(SQI) );

	hSQI->hLog				= hLog;
	hSQI->hStmtList			= lstOpen();
	hSQI->pszCatalogFile	= (char*)strdup( pszCatalogFile );
	hSQI->pszName			= 0;
	hSQI->pszDescription	= 0;
	hSQI->pszDefaultPath	= 0;

	lstSetFreeFunc( hSQI->hStmtList, _sqiCloseStmt );

	/* sqi is single user so load table cache here.... */
	if ( !_sqiOpenDatabase( hSQI ) )
	{
		logPushMsg( hSQI->hLog, __FILE__, __FILE__, __LINE__, LOG_INFO, SQI_ERROR, "Had problems loading the database." );
	}
	
	/* finalize */
	*phSQI = hSQI;

	sprintf( hSQI->szMsg, "hSQI (%p) created for %s", hSQI, pszCatalogFile );
	logPushMsg( hSQI->hLog, __FILE__, __FILE__, __LINE__, LOG_INFO, SQI_SUCCESS, hSQI->szMsg );

	return true;
}



