#include "sqi.h"

/********************************************
 * sqiOpenStmt
 *
 *
 ********************************************/
int sqiOpenStmt( HSQI hSQI, HSQISTMT *phStmt )
{
	HSQISTMT	hStmt;
	HLOG		hLog;

	if ( !hSQI )
		return false;
	
	sprintf( hSQI->szMsg, "hSQI (%p) phStmt (%p)", hSQI, phStmt );
	logPushMsg( hSQI->hLog, __FILE__, __FILE__, __LINE__, LOG_INFO, SQI_SUCCESS, hSQI->szMsg );

	if ( !logOpen( &hLog, "SQI", NULL, 20 ) )
	{
		logPushMsg( hSQI->hLog, __FILE__, __FILE__, __LINE__, LOG_INFO, SQI_SUCCESS, "Failed to open a log" );
		return false;
	}

	hStmt = malloc( sizeof(SQISTMT) );
	hStmt->hLog					= hLog;
	hStmt->hSQI					= hSQI;
	hStmt->hTableResult			= NULL;
	hStmt->nRowsAffected		= -1;
	hStmt->nType				= -1;
	hStmt->pParsedSQL			= NULL;
	hStmt->pszSQL				= NULL;

	lstAppend( hSQI->hStmtList, hStmt );

	*phStmt = hStmt;

	sprintf( hSQI->szMsg, "hStmt (%p) created.", hStmt );
	logPushMsg( hSQI->hLog, __FILE__, __FILE__, __LINE__, LOG_INFO, SQI_SUCCESS, hSQI->szMsg );

	return true;
}



