#include "sqi.h"

/********************************************
 * sqiPrepare
 *
 ********************************************/

int sqiPrepare( HSQISTMT hStmt, char *pszSQL )
{
	if ( !hStmt )
		return false;
	
	if ( hStmt->pParsedSQL )
		_sqiFreeParsedSQL( hStmt );

	if ( hStmt->hTableResult )
		sqiFreeResult( hStmt );

	/******************************************
	 * INIT SOME VARS FOR PARSE
	 ******************************************/
	hStmt->pszSQL	= (char*)strdup( pszSQL );
	sqpClearGlobals();
	g_pszSQLCursor	= hStmt->pszSQL;
	g_pszSQLLimit	= &(hStmt->pszSQL[strlen(hStmt->pszSQL)]);

	/******************************************
	 * PARSE
	 ******************************************/
	if ( yyparse() != 0 )	
	{
		logPushMsg( hStmt->hLog, __FILE__, __FILE__, __LINE__, LOG_WARNING, LOG_WARNING, g_szError );
		sqpFreeGlobals();
        free( hStmt->pszSQL );
        hStmt->pszSQL	= NULL;
		return false;
	}

	/******************************************
	 * SUCCESS!
	 * Our globals have been adopted by hStmt;
	 ******************************************/
	if ( g_pUpdate )
	{
		hStmt->nType		= sqpupdate;
		hStmt->pParsedSQL	= g_pUpdate;
	}
	else if ( g_pInsert )
	{
		hStmt->nType		= sqpinsert;
		hStmt->pParsedSQL	= g_pInsert;
	}
	else if ( g_pDelete )
	{
		hStmt->nType		= sqpdelete;
		hStmt->pParsedSQL	= g_pDelete;
	}
	else if ( g_pSelect )
	{
		hStmt->nType		= sqpselect;
		hStmt->pParsedSQL	= g_pSelect;
	}
	else
	{
		logPushMsg( hStmt->hLog, __FILE__, __FILE__, __LINE__, LOG_WARNING, LOG_WARNING, "Parse seemed to work but unknown SQL" );
		sqpFreeGlobals();
        free( hStmt->pszSQL );
        hStmt->pszSQL	= NULL;
		return false;
	}
	sqpClearGlobals();

	return true;
}



