#include "sqi.h"

/************************
 *
 * Assumes hTable->hRows->hCurrent is set to the desired row and is
 * stable. Make sure that hTable is a cursor if concurrent access
 * to root is possible; this will help ensure a stable hCurrent.
 *
 ************************/
int sqiSetColumn( HSQITABLE hTable, int nRootColumn, char *pszValue )
{
	char **aCols;

    if ( !hTable )
		return false;

    if ( !pszValue )
		return false;
	
	if ( nRootColumn < 0 )
		return false;

	if ( lstEOL( hTable->hRows ) )
		return false;

/********[ good place for a row level lock ]**************/

	aCols = (char**)lstGet( hTable->hRows );

	if ( aCols[nRootColumn] )
	{
		aCols[nRootColumn] = realloc( aCols[nRootColumn], strlen(pszValue)+1 );
        aCols[nRootColumn] = (char*)strdup( pszValue );
	}
	else
		aCols[nRootColumn] = pszValue;

	return true;
}



