#include "sqi.h"

/********************************************
 * sqiTables
 *
 ********************************************/
int sqiTables( HSQISTMT hStmt )
{
	HSQI		hSQI;
	HSQITABLE	hTable;
	char		**pData;

	if ( !hStmt )
		return false;

	sprintf( hStmt->szMsg, "hStmt (%p)", hStmt );
	logPushMsg( hStmt->hLog, __FILE__, __FILE__, __LINE__, LOG_INFO, SQI_SUCCESS, hStmt->szMsg );

	if ( hStmt->hTableResult )
		sqiFreeResult( hStmt );

	hSQI = (HSQI)hStmt->hSQI;

	hStmt->hTableResult 				= malloc( sizeof(SQITABLE) );
	hStmt->hTableResult->pszTableName	= (char*)strdup( "sqiTables" );
	hStmt->hTableResult->pszFileName	= NULL;
	hStmt->hTableResult->nRefs			= 0;
	hStmt->hTableResult->hBase			= NULL;

	/* table header */
	hStmt->hTableResult->hColHdrs	= lstOpen();
	lstSetFreeFunc( hStmt->hTableResult->hColHdrs, _sqiFreeColumnHeader );

	lstAppend( hStmt->hTableResult->hColHdrs, _sqiNewColumnHeader( 0, "system", "sqiColumns", "TABLE_CAT", SQL_VARCHAR, 50 ) );
	lstAppend( hStmt->hTableResult->hColHdrs, _sqiNewColumnHeader( 1, "system", "sqiColumns", "TABLE_SCHEM", SQL_VARCHAR, 50 ) );
	lstAppend( hStmt->hTableResult->hColHdrs, _sqiNewColumnHeader( 2, "system", "sqiColumns", "TABLE_NAME", SQL_VARCHAR, 50 ) );
	lstAppend( hStmt->hTableResult->hColHdrs, _sqiNewColumnHeader( 3, "system", "sqiColumns", "TABLE_TYPE", SQL_VARCHAR, 50 ) );
	lstAppend( hStmt->hTableResult->hColHdrs, _sqiNewColumnHeader( 4, "system", "sqiColumns", "REMARKS", SQL_VARCHAR, 50 ) );

	/* table rows (based upon root table col hdrs) */
	hStmt->hTableResult->hRows		= lstOpen();
	lstSetFreeFunc( hStmt->hTableResult->hRows, _sqiFreeDataRow );

	if ( hSQI->hTableCache )
	{
		lstFirst( hSQI->hTableCache );
		while ( !lstEOL( hSQI->hTableCache ) )
		{
			hTable		= lstGet( hSQI->hTableCache );

			pData		= malloc( sizeof(char *)*6 );

			pData[0]	= (char *)strdup( hSQI->pszName );
			pData[1]	= (char *)strdup( hSQI->pszName );
			pData[2]	= (char *)strdup( hTable->pszTableName );
			pData[3]	= (char *)strdup( "" );
			pData[4]	= (char *)strdup( hTable->pszDescription );

			pData[5]	= NULL; /* data terminator... see _sqiFreeDataRow */

			lstAppend( hStmt->hTableResult->hRows, pData );

			lstNext( hSQI->hTableCache );
		}
	}

	hStmt->nRowsAffected	= hStmt->hTableResult->hRows->nItems;

	/* we should be EOL for call to fetch */
	lstLast( hStmt->hTableResult->hRows );
	lstNext( hStmt->hTableResult->hRows );

	return true;
}

