#include "sqp.h"

void sqpFreeGlobals()
{
	*g_szError		= '\0';

#ifdef SQPDEBUG
	printf( "[SQP][%s][%d]\n", __FILE__, __LINE__ );
#endif

	if ( g_pUpdate )
	{
		 sqpFreeUpdate( g_pUpdate );
	}
	else if ( g_pSelect )
	{
		sqpFreeSelect( g_pSelect );
	}
	else if ( g_pInsert )
	{
		sqpFreeInsert( g_pInsert );
	}
	else if ( g_pDelete	)
	{
		sqpFreeInsert( g_pDelete );
	}
	else
	{
		/* these guys were not adopted by above structs so */
		if ( g_pszTable )
			free(g_pszTable);
		if ( g_hColumns )
		{
			lstSetFreeFunc( g_hColumns, sqpFreeColumn );
			lstClose( g_hColumns );
		}
		if ( g_hComparisons )
		{
			lstSetFreeFunc( g_hComparisons, sqpFreeComparison );
			lstClose( g_hComparisons );
		}
		if ( g_hValues )
			lstClose( g_hValues );
		if ( g_hAssignments	)
		{
			lstSetFreeFunc( g_hAssignments, sqpFreeAssignment );
			lstClose( g_hAssignments );
		}
		if ( g_pszCursor )
			free(g_pszCursor);
	}

	sqpClearGlobals();

#ifdef SQPDEBUG
	printf( "[SQP][%s][%d]\n", __FILE__, __LINE__ );
#endif

}


