#ifndef _TRE_H
#define _TRE_H

#include <stdlib.h>
#include <stdio.h>
/* #include <ctype.h> */
#include <string.h>

#ifndef bool
#define bool int
#endif

#ifndef true
#define true 1
#define false 0
#endif

#define TRE_SUCCESS 1
#define TRE_ERROR 0

typedef struct	tTREITEM
{
	struct	tTREITEM	*hParent;

	struct	tTREITEM	*hPrev;
	struct	tTREITEM	*hNext;

	struct	tTREITEM	*hChildFirst;
	struct	tTREITEM	*hChildLast;

	void 	*pData;

} TREITEM, *HTREITEM;


typedef struct tTRE
{
	HTREITEM	hItemTop;
	HTREITEM	hItemCurrent;

} TRE, *HTRE;



int treOpen( HTRE *phTre, void *pData );
int treClose( HTRE hTre, bool bFreeData );
int treTop( HTRE hTre );
int treUp( HTRE hTre );
int treDown( HTRE hTre );
int trePrev( HTRE hTre );
int treNext( HTRE hTre );
int treFirst( HTRE hTre );
int treLast( HTRE hTre );
bool treIsTop( HTRE hTre );
bool treIsFirst( HTRE hTre );
bool treIsLast( HTRE hTre );
bool treIsBottom( HTRE hTre );
void *treGet( HTRE hTre );
int treRemove( HTRE hTre, bool bFreeData );

int treAddChild( HTRE hTre, void *pData );
int treAddSibling( HTRE hTre, void *pData );


#endif


