#include "tre.h"

int treAddChild( HTRE hTre, void *pData )
{
    HTREITEM	hParent;
    HTREITEM	hChild;

	if ( !hTre )
		return TRE_ERROR;

	if ( !hTre->hItemCurrent )
		return TRE_ERROR;

	hParent = hTre->hItemCurrent;

	/* CREATE CHILD */
	hChild				= malloc( sizeof(TREITEM) );
	hChild->hParent		= hParent;
	hChild->hChildFirst	= NULL;
	hChild->hChildLast	= NULL;
	hChild->pData		= pData;

	/* POSITION CHILD IN TREE (below current and at end of its child list */
	if ( hParent->hChildFirst )
	{
		hParent->hChildLast->hNext	= hChild;
		hChild->hNext				= NULL;
		hChild->hPrev				= hParent->hChildLast;
		hParent->hChildLast			= hChild;

	}
	else
	{
		hParent->hChildFirst	= hChild;
		hParent->hChildLast		= hChild;
		hChild->hNext			= NULL;
		hChild->hPrev			= NULL;
	}

    hTre->hItemCurrent = hChild;

	return TRE_SUCCESS;
}

