#include "tre.h"

int treAddSibling( HTRE hTre, void *pData )
{
    HTREITEM	hSibling;

	if ( !hTre )
		return TRE_ERROR;

	if ( !hTre->hItemCurrent )
		return TRE_ERROR;

	if ( treIsTop( hTre ) )			/* ONLY ONE ITEM ALLOWED TO BE TOP */
		return TRE_ERROR;

	/* CREATE SIBLING */
	hSibling				= malloc( sizeof(TREITEM) );
	hSibling->hParent		= hTre->hItemCurrent->hParent;
	hSibling->hChildFirst	= NULL;
	hSibling->hChildLast	= NULL;
	hSibling->pData			= pData;

	/* POSITION CHILD IN TREE (at end of current child list) */
	hSibling->hParent->hChildLast->hNext	= hSibling;
	hSibling->hNext							= NULL;
	hSibling->hPrev							= hSibling->hParent->hChildLast;
	hSibling->hParent->hChildLast			= hSibling;

	return TRE_SUCCESS;
}

