#include "tre.h"

int treClose( HTRE hTre, bool bFreeData )
{
	if ( !hTre )
		return TRE_ERROR;

	if ( !treTop( hTre ) )
		return TRE_ERROR;


	/* REMOVE DATA BELOW TOP */
	if ( treDown( hTre ) )
	{
		while ( treLast( hTre ) )
		{
			treRemove( hTre, bFreeData );
		}
	}


	/* FREE TOP */
	if ( bFreeData )
		free( hTre->hItemTop->pData );

	free( hTre );


	return TRE_SUCCESS;
}




