#include "tre.h"

int treRemove( HTRE hTre, bool bFreeData )
{
	HTREITEM	hBookmark;

	if ( !hTre )
		return TRE_ERROR;

	if ( !hTre->hItemCurrent )
		return TRE_ERROR;

	if ( treIsTop( hTre ) )				/* DO NOT ALLOW REMOVE OF TOP ITEM... CLOSE TREE IF YOU WANT TO DO THIS */
		return TRE_ERROR;

	hBookmark = hTre->hItemCurrent;

	/* REMOVE DEPENDENT DATA */
	if ( treDown( hTre ) )
	{
		while ( treLast( hTre ) )
		{
			treRemove( hTre, bFreeData );
		}
	}

	/* REMOVE FROM LIST AND UPDATE CURRENT POSITION */
	if ( hBookmark->hPrev )
	{
		hTre->hItemCurrent = hBookmark->hPrev;
		hBookmark->hPrev->hNext = hBookmark->hNext;
	}
	else if ( hBookmark->hNext )
	{
		hTre->hItemCurrent = hBookmark->hNext;
		hBookmark->hNext->hPrev = hBookmark->hPrev;
	}
	else if ( hBookmark->hParent )
	{
		hTre->hItemCurrent = hBookmark->hParent;
	}

	/* UPDATE PARENT */
	if ( hBookmark->hParent )
	{
		if ( !hBookmark->hPrev )
			hBookmark->hParent->hChildFirst = hBookmark->hNext;
		if ( !hBookmark->hNext )
			hBookmark->hParent->hChildLast = hBookmark->hPrev;
	}

	/* FREE MEM */
	if ( hBookmark->pData && bFreeData )
		free( hBookmark->pData );

	free( hBookmark );

	return TRE_SUCCESS;
}

